@ECHO OFF
SET version=2.12.200306
SET my_data=0
SET ext_inf_error=0

for /f "tokens=3" %%v in ('reg query "HKLM\Software\ASUS\ICEpower_APO" /V DisplayVersion  ^|findstr /ri "REG_SZ"') do (SET my_data=%%v)

IF %my_data% EQU 0 GOTO param_function_1

for /f "tokens=1-3 delims=." %%A in ("%my_data%") do (
	for /f "tokens=1 delims=." %%G in ("%version%") do (
		IF %%A GTR %%G GOTO param_function_3
		IF %%A EQU %%G (
			for /f "tokens=2 delims=." %%G in ("%version%") do (
				IF %%B GTR %%G (
					GOTO param_function_3
				)
				IF %%B EQU %%G (
					for /f "tokens=3 delims=." %%G in ("%version%") do (
						IF %%C GTR %%G (
							GOTO param_function_3
						)
						IF %%C EQU %%G (
							GOTO param_function_4
						)
						IF %%C LSS %%G (
							GOTO param_function_5
						)
					)
				)
				IF %%B LSS %%G GOTO param_function_5
			)
		)
		IF %%A LSS %%G GOTO param_function_5
	)
)

REM PAUSE
EXIT /B 0

:param_function_1
ECHO ICEsound APO never installed, install %version% now!
CALL :param_function_5
REM PAUSE
EXIT /B 0

:param_function_3
ECHO APO %my_data% installed, version is greater than this one version %version%, install stop!
REM PAUSE
EXIT /B 0

:param_function_4
ECHO APO %version% already installed in system, reinstall!
CALL :param_function_5
REM PAUSE
EXIT /B 0

:param_function_5
ECHO Installing extension inf.
pnputil /add-driver ./OemXAudioExtICEsoundAPO/OemXAudioExtICEsoundAPO.inf /install

ECHO Installing APO component inf.
pnputil /add-driver ./ICEsoundAPO64/ICEsoundAPO64.inf /install

ECHO Installing AudioWizard UWP HSA component.
pnputil /add-driver ./AudioWizard_UWP_HSA/AudioWizardHSA.inf /install

REG ADD HKLM\Software\ASUS\ICEpower_APO /v "DisplayVersion" /t REG_SZ /d %version% /f
